#!/bin/bash

### Purpose
# This installation script patches the wrapper shell "veye"
# so as to reflect the actual installation directory
#
# It may be ran as many times as needed, diong so is harmless
###

usage () {
  echo "Usage: $COMMAND [install-dir]"
  echo ""
  echo "This command patches the veye wrapper"
  echo "  in accordance with your installation directory"
  echo ""
  echo "Without an argument, the installation dir is guessed"
  echo "  from the location where $0 was found"
  echo "You can provide an explicit location if needed"
}
 

COMMAND=$(basename $0)
ARGVDIR=$(dirname $0)

[ -n "$DEBUG" ] && set -x

cd $ARGVDIR

if [ ! -f veye ] ; then
  echo "$COMMAND : could not find scritp veye in $(pwd)"
  echo "Aborted"
  exit 1
fi

if [[ -z "$@" ]] ; then
  canonicalDir=$( (cd .. ; pwd))
else
  case "$1" in
    -*)
      usage
      exit 1 ;;
    *)
      canonicalDir="$1" ; shift ;;
  esac
fi
      

cp veye veye.bak
sed -e 's,^export PREFIX=.*,export PREFIX='"$canonicalDir", veye.bak > veye

echo "####################"
echo "File $(pwd)/veye now uses as installation dir "
echo "     $canonicalDir"
echo "####################"
