#!/usr/bin/wish

frame .g 
frame .m
frame .d
pack .g -side left
pack .m -side left
pack .d -side right

label .g.host -fg red -text "Linux" -width 16
tk_optionMenu .m.host host  "soleil" "venus" "lune" "pluton" "halley"  "spoutnik"

pack .g.host -side top -pady 5
pack .m.host -side top -pady 2

label .g.nb -text "Nb Participants" -width 16
entry .m.nb -textvariable nb -width 4
pack .g.nb -side top -pady 4
pack .m.nb -side top -pady 2
.m.nb insert 0 50

label .g.exitTime -text "Exit (min)" -width 16
entry .m.exitTime -textvariable exitTime -width 4
pack .g.exitTime -side top -pady 4
pack .m.exitTime -side top -pady 2
.m.exitTime insert 0 5

label .g.update -text "Update (ms)" -width 16
entry .m.update -textvariable update -width 4
pack .g.update -side top -pady 4
pack .m.update -side top -pady 2
.m.update insert 0 100

label .g.alive -text "Keep Alive (ms)" -width 16
entry .m.alive -textvariable alive -width 6
pack .g.alive -side top -pady 4
pack .m.alive -side top -pady 2
.m.alive insert 0 10000

label .g.posX -text "Position (X)" -width 16
entry .m.posX -textvariable posX -width 4
pack .g.posX -side top -pady 4
pack .m.posX -side top -pady 2
.m.posX insert 0 390

label .g.posY -text "Position (Y)" -width 16
entry .m.posY -textvariable posY -width 4
pack .g.posY -side top -pady 4
pack .m.posY -side top -pady 2
.m.posY insert 0 410

label .g.fact -text "Fact" -width 16
entry .m.fact -textvariable fact -width 4
pack .g.fact -side top -pady 4
pack .m.fact -side top -pady 2
.m.fact insert 0 100

label .g.theta -text "Angle (degrees)" -width 16
entry .m.theta -textvariable theta -width 4
pack .g.theta -side top -pady 4
pack .m.theta -side top -pady 2
.m.theta insert 0 20

label .g.translate -text "Translate" -width 16
entry .m.translate -textvariable translate -width 4
pack .g.translate -side top -pady 4
pack .m.translate -side top -pady 2
.m.translate insert 0 0.1

label .g.agent -text "Agent" -width 16
entry .m.agent -textvariable agent -width 12
pack .g.agent -side top -pady 4
pack .m.agent -side top -pady 2
.m.agent insert 0 "soleil.inria.fr"

checkbutton .d.nobind -text "No Bind" -variable nbd -onvalue {nbd = "-nobind"} -offvalue {nbd = ""} 
pack .d.nobind -padx 24

checkbutton .d.random -text "Random" -variable rand -onvalue {rand = "-random"} -offvalue {rand = "-follow"} 
pack .d.random -padx 24

checkbutton .d.randomtext -text "Random Text" -variable randtxt -onvalue {randtxt = "-txt"} -offvalue {randtxt = ""} 
pack .d.randomtext -padx 24

button .d.goAll -text "Apply on all hosts !" -command goAll -width 12
button .d.go -text "Apply on host !" -command go -width 12
button .d.kill -text "Kill'em all !" -command killAll -width 12
button .d.quit -text "Quit" -command quit -width 12

pack .d.goAll -padx 24
pack .d.go -padx 24
pack .d.kill -padx 29
pack .d.quit -padx 24

puts "Running...."
proc goAll { } {
    run soleil
    run venus
    run lune
    run pluton
    run halley
    run spoutnik
}

proc killAll { } {
    killon soleil
    killon venus
    killon lune
    killon pluton
    killon halley
    killon spoutnik
}				
proc go { } {
    global host 
    
    run $host
    
}
proc run { hostname } {
    global theta update alive exitTime translate posX posY fact agent nb nbd rand randtxt env
    
    if { [ llength [ array get env HOST ] ] == 2  && ("$hostname"=="$env(HOST)") } then {
	exec pgl_auto $nbd $rand $randtxt -agent $agent -name $hostname -n $nb -dx $translate -pos $posX $posY -fact $fact -theta $theta -update $update -alive $alive -exit $exitTime &
	
    } else {

	exec ssh $hostname pgl_auto $nbd $rand $randtxt -agent $agent -name $hostname -n $nb -dx $translate -pos $posX $posY -fact $fact -theta $theta -update $update -alive $alive -exit $exitTime &
	
	 
    }
}
proc killon { hostname } {
    global env
    if { [ llength [ array get env HOST ] ] == 2  && ("$hostname"=="$env(HOST)") } then {
	exec killall pgl_auto
    } else {
	exec ssh $hostname killall pgl_auto
    }
}
proc fin { } {
    global host env
    
    if { [ llength [ array get env HOST ] ] == 2  && ("$host"=="$env(HOST)") } then {
	exec killall pgl_auto
    } else {
	exec rsh $host killall pgl_auto
    }
}
proc quit {} {
    destroy .
}
